edelib: TiXmlElement Class Reference

edelib 1.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
TiXmlElement Class Reference

Container xml class. More...

`#include <edelib/TiXml.h>`

Inheritance diagram for TiXmlElement:

## Public Member Functions
| TiXmlElement (const char *in_value)
| TiXmlElement (const TiXmlElement &)
void | operator= (const TiXmlElement &base)
virtual | ~TiXmlElement ()
const char * | Attribute (const char *name) const
const char * | Attribute (const char *name, int *i) const
const char * | Attribute (const char *name, double *d) const
int | QueryIntAttribute (const char *name, int *_value) const
int | QueryDoubleAttribute (const char *name, double *_value) const
int | QueryFloatAttribute (const char *name, float *_value) const
void | SetAttribute (const char *name, const char *_value)
void | SetAttribute (const char *name, int value)
void | SetDoubleAttribute (const char *name, double value)
void | RemoveAttribute (const char *name)
const TiXmlAttribute * | FirstAttribute () const
TiXmlAttribute * | FirstAttribute ()
const TiXmlAttribute * | LastAttribute () const
TiXmlAttribute * | LastAttribute ()
const char * | GetText () const
virtual TiXmlNode * | Clone () const
virtual void | Print (FILE *cfile, int depth) const
virtual const char * | Parse (const char *p, TiXmlParsingData *data, TiXmlEncoding encoding)
virtual const TiXmlElement * | ToElement () const
virtual TiXmlElement * | ToElement ()
virtual bool | Accept (TiXmlVisitor *visitor) const
Public Member Functions inherited from TiXmlNode
const char * | Value () const
void | SetValue (const char *_value)
void | Clear ()
TiXmlNode * | Parent ()
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
const TiXmlNode * | PreviousSibling () const
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
virtual const TiXmlDocument * | ToDocument () const
virtual const TiXmlComment * | ToComment () const
virtual const TiXmlUnknown * | ToUnknown () const
virtual const TiXmlText * | ToText () const
virtual const TiXmlDeclaration * | ToDeclaration () const
virtual TiXmlDocument * | ToDocument ()
virtual TiXmlComment * | ToComment ()
virtual TiXmlUnknown * | ToUnknown ()
virtual TiXmlText * | ToText ()
virtual TiXmlDeclaration * | ToDeclaration ()
Public Member Functions inherited from TiXmlBase
int | Row () const
int | Column () const
void | SetUserData (void *user)
void * | GetUserData ()
const void * | GetUserData () const

## Additional Inherited Members
Public Types inherited from TiXmlNode
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
Protected Member Functions inherited from TiXmlNode
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)
Static Protected Member Functions inherited from TiXmlBase
static const char * | ReadName (const char *p, edelib::String *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, edelib::String *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static void | PutString (const edelib::String &str, edelib::String *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Container xml class.

The element is a container class. It has a value, the element name, and can contain other elements, text, comments, and unknowns. Elements also contain an arbitrary number of attributes.

## Constructor & Destructor Documentation

TiXmlElement | ( | const char * | in_value | ) |

Construct an element

TiXmlElement | ( | const TiXmlElement & |  | ) |

Construct an element from previous TiXmlElement

virtual ~TiXmlElement | ( |  | ) |
| virtual

Hem... destructor

## Member Function Documentation

virtual bool Accept | ( | TiXmlVisitor * | visitor | ) | const
| virtual

Walk the XML tree visiting this node and all of its children

Implements TiXmlNode.

Referenced by TiXmlNode::ToDeclaration(), and TiXmlText::ToText().

const char* Attribute | ( | const char * | name | ) | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists.

const char* Attribute | ( | const char * | name,
|  | int * | i
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an integer, the integer value will be put in the return 'i', if 'i' is non-null.

const char* Attribute | ( | const char * | name,
|  | double * | d
| ) |  | const

Given an attribute name, Attribute() returns the value for the attribute of that name, or null if none exists. If the attribute exists and can be converted to an double, the double value will be put in the return 'd', if 'd' is non-null.

virtual TiXmlNode* Clone | ( |  | ) | const
| virtual

Creates a new Element and returns it - the returned element is a copy

Implements TiXmlNode.

Referenced by TiXmlNode::ToDeclaration(), and TiXmlText::ToText().

const TiXmlAttribute* FirstAttribute | ( |  | ) | const
| inline

Access the first attribute in this element.

TiXmlAttribute* FirstAttribute | ( |  | ) |
| inline

Access the first attribute in this element.

const char* GetText | ( |  | ) | const

Convenience function for easy access to the text inside an element. Although easy and concise, GetText() is limited compared to getting the TiXmlText child and accessing it directly.

If the first child of 'this' is a TiXmlText, the GetText() returns the character string of the Text node, else null is returned.

This is a convenient method for getting the text of simple contained text:

    *   <foo>This is text</foo>
    *   const char* str = fooElement->GetText();
    *

'str' will be a pointer to "This is text".

Note that this function can be misleading. If the element foo was created from this XML:

    *   <foo><b>This is text</b></foo>
    *

then the value of str would be null. The first child node isn't a text node, it is another element. From this XML:

    *   <foo>This is <b>text</b></foo>
    *

GetText() will return "This is ".

WARNING: GetText() accesses a child node - don't become confused with the similarly named TiXmlHandle::Text() and TiXmlNode::ToText() which are safe type casts on the referenced node.

const TiXmlAttribute* LastAttribute | ( |  | ) | const
| inline

Access the last attribute in this element.

TiXmlAttribute* LastAttribute | ( |  | ) |
| inline

Access the last attribute in this element.

void operator= | ( | const TiXmlElement & | base | ) |

Construct an element from previous TiXmlElement

Referenced by TiXmlNode::ToDeclaration().

virtual const char* Parse | ( | const char * | p,
|  | TiXmlParsingData * | data,
|  | TiXmlEncoding | encoding
| ) |  |
| virtual

Attribtue parsing starts: next char past '<' returns: next char past '>'

Referenced by TiXmlText::SetCDATA().

virtual void Print | ( | FILE * | cfile,
|  | int | depth
| ) |  | const
| virtual

Print the Element to a FILE stream

Implements TiXmlBase.

Referenced by TiXmlText::operator=().

int QueryDoubleAttribute | ( | const char * | name,
|  | double * | _value
| ) |  | const

QueryDoubleAttribute examines the attribute - see QueryIntAttribute()

int QueryFloatAttribute | ( | const char * | name,
|  | float * | _value
| ) |  | const
| inline

QueryFloatAttribute examines the attribute - see QueryIntAttribute()

int QueryIntAttribute | ( | const char * | name,
|  | int * | _value
| ) |  | const

QueryIntAttribute examines the attribute - it is an alternative to the Attribute() method with richer error checking. If the attribute is an integer, it is stored in 'value' and the call returns TIXML_SUCCESS. If it is not an integer, it returns TIXML_WRONG_TYPE. If the attribute does not exist, then TIXML_NO_ATTRIBUTE is returned.

void RemoveAttribute | ( | const char * | name | ) |

Deletes an attribute with the given name.

void SetAttribute | ( | const char * | name,
|  | const char * | _value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

void SetAttribute | ( | const char * | name,
|  | int | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

void SetDoubleAttribute | ( | const char * | name,
|  | double | value
| ) |  |

Sets an attribute of name to a given value. The attribute will be created if it does not exist, or changed if it does.

virtual const TiXmlElement* ToElement | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null not of the requested type

Reimplemented from TiXmlNode.

virtual TiXmlElement* ToElement | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null not of the requested type

Reimplemented from TiXmlNode.

The documentation for this class was generated from the following file:

- edelib/TiXml.h